matrix/hr/urls.py
from django.conf.urls import url
from .views import (activate_item, employee_list, employee_ajax, employee_detail,
        employee_create, employee_update, employee_vacations,
        employee_documents, employee_documents_add, employee_documents_update,
        employee_documents_delete, employee_services, employee_services_add,
        employee_services_update, employee_services_delete, item_process, vacation_create,
        agent_list, agent_ajax, agent_detail, agent_create, agent_update, worker_list,
        workers_ajax, worker_detail, worker_update, worker_create, item_list,
        items_ajax, item_detail, item_create, item_update, receipt_list, receipts_ajax,
        receipt_detail, item_process, workers_wizard_ajax, receive_info, download_receipt_PDF,
        item_delete, receipt_delete, workers_wizard_ajax )
from .views import (TechnicianViewSet,BuildingContactViewSet,GearViewSet,
        AvailabilityViewSet,NetworkEquipmentViewSet, usuarios_activos, set_config)

from hr.autocompletes import TechnicianAutocomplete

# API section
from customers.urls import router
router.register(r"technicians", TechnicianViewSet)
router.register(r"building-contacts", BuildingContactViewSet)
router.register(r"gears", GearViewSet)
router.register(r"availabilities", AvailabilityViewSet)
router.register(r"network-equipments", NetworkEquipmentViewSet)

urlpatterns = [
    url(r'^employees/$', employee_list, name='employee-list'),
    url(r'^employees/actives$', usuarios_activos, name='usuarios-activos'),
    url(r'^employees/(?P<pk>\d+)/$', employee_detail, name='employee-detail'),
    url(r'^employees/add/$', employee_create, name='employee-add'),
    url(r'^employees/(?P<pk>\d+)/edit/$', employee_update, name='employee-update'),
    url(r'^employees/(?P<pk>\d+)/documents/$', employee_documents, name='employee-documents'),
    url(r'^employees/(?P<pk>\d+)/documents/add/$', employee_documents_add, name='employee-documents-add'),
    url(r'^employees/(?P<pk>\d+)/documents/(?P<document_pk>\d+)/edit/$', employee_documents_update, name='employee-documents-update'),
    url(r'^employees/(?P<pk>\d+)/documents/(?P<document_pk>\d+)/delete/$', employee_documents_delete, name='employee-documents-delete'),    url(r'^employees/(?P<pk>\d+)/services/$', employee_services, name='employee-services'),
    url(r'^employees/(?P<pk>\d+)/services/add/$', employee_services_add, name='employee-services-add'),
    url(r'^employees/(?P<pk>\d+)/services/(?P<document_pk>\d+)/edit/$', employee_services_update, name='employee-services-update'),
    url(r'^employees/(?P<pk>\d+)/services/(?P<document_pk>\d+)/delete/$', employee_services_delete, name='employee-services-delete'),
    url(r'^employees/(?P<pk>\d+)/payslips/$', employee_detail, name='employee-payslips'),
    url(r'^employees/(?P<pk>\d+)/vacations/$', employee_vacations, name='employee-vacations'),
    url(r'^employees/(?P<pk>\d+)/vacations/add/$', vacation_create, name='employee-vacations-add'),
    url(r'^employees/ajax/$', employee_ajax, name='employee-ajax'),
    url(r"^agents/$", agent_list, name="agent-list"),
    url(r"^agents/ajax/$", agent_ajax, name="agent-ajax"),
    url(r"^agents/(?P<pk>\d+)/$", agent_detail, name="agent-detail"),
    url(r"^agents/new/$", agent_create, name="agent-create"),
    url(r"^agents/(?P<pk>\d+)/edit/$", agent_update, name="agent-update"),
    url(r"^set_config$", set_config, name="set-config"),
    url(r"^tecnicos-ac/", TechnicianAutocomplete.as_view(), name="tecnicos-ac"),
    url(r"^workers/$", worker_list, name='worker-list'),
    url(r"^workers/ajax/$", workers_ajax, name='worker-ajax'),
    url(r"^workers/(?P<pk>\d+)/$", worker_detail, name='worker-detail'),
    url(r"^workers/(?P<pk>\d+)/edit/$", worker_update, name='worker-update'),
    url(r"^workers/new/$", worker_create, name ='worker-create'),
    url(r"^items/$", item_list, name='item-list'),
    url(r"^items/ajax/$",items_ajax, name='item-ajax'),
    url(r"^items/(?P<pk>\d+)/$", item_detail, name='item-detail'),
    url(r"^items/(?P<pk>\d+)/edit/$", item_update, name='item-update'),
    url(r"^items/(?P<pk>\d+)/delete/$", item_delete, name='item-delete'),
    url(r"^items/activate/$", activate_item, name='activate-item'),
    url(r"^items/new/$", item_create, name = 'item-create'),
    url(r"^receipts/$", receipt_list, name = 'receipt-list'),
    url(r"^receipts/ajax/$", receipts_ajax, name='receipt-ajax'),
    url(r"^receipts/(?P<pk>\d+)/$", receipt_detail, name='receipt-detail'),
    url(r"^receipts/(?P<pk>\d+)/delete/$", receipt_delete, name='receipt-delete'),
    url(r"^item_process/$", item_process, name='item-process'),
    url(r"^item_process/worker_ajax/$", workers_wizard_ajax, name='worker-wizard-ajax'),
    url(r"^item_process/receive_info/$", receive_info, name='receive-info'),
    url(r"^receipts/(?P<pk>\d+)/download_pdf/$", download_receipt_PDF, name ="download-receipt-pdf"),
]

matrix/infra/urls.py
from django.conf.urls import url, include
from .views import (node_list, refresh_network_equipment, nodes_cities,
    node_create, node_detail, node_refresh, node_location,node_activities,
    node_activity_add, node_update, node_fiber_update, node_gear, node_gallery,
    node_gallery_add, node_gallery_mass_add, node_gallery_update, node_documents,
    node_documents_add, node_services, node_leases,  node_tie_address, 
    node_untie_address, find_availability, find_availability_api, 
    RegionAutocomplete, StreetAutocomplete, ComunaAutocomplete,
    DireccionAutocomplete, node_ajax, node_available_ips_ajax, gear_list, 
    gear_detail, gear_ajax, gear_create, gear_update, gear_gallery,
    gear_gallery_add, gear_gallery_update, gear_gallery_delete,
    gear_documents, gear_documents_add, gear_documents_update,
    gear_documents_delete, NodeViewSet
    )
from infra.infra_viewsets import (
    NetworkEquipmentViewSet
)
from infra.infra_views import (
    NetworkEquipmentView
)
from infra.autocompletes import (
    IPNetworkEquipmenAutocomplete,
    MACNetworkEquipmenAutocomplete,
    ServiceNumNetworkEquipmenAutocomplete
)
from customers.urls import router
router.register(r"nodes", NodeViewSet)

urlpatterns = [
    url(
        r"^network-equipment-api",
        NetworkEquipmentViewSet.as_view({'get': 'list'}),
        name="network_equipment_api"
        ),
    url(
        "network-equipment",
        NetworkEquipmentView.as_view(),
        name="network_equipment"
    ),

    url(
        "autocompletes/ips-networks-equipment/",
        IPNetworkEquipmenAutocomplete.as_view(),
        name="ac_ips_networks_equipment"
    ),
    url(
        "autocompletes/macs-networks-equipment/",
        MACNetworkEquipmenAutocomplete.as_view(),
        name="ac_macs_networks_equipment"
    ),
    url(
        "autocompletes/service-networks-equipment/",
        ServiceNumNetworkEquipmenAutocomplete.as_view(),
        name="ac_service_networks_equipment"
    ),

    url(r"^nodes/$", node_list, name="node-list"),
    url(
        r"^nodes/refresh-network-equipment/$",
        refresh_network_equipment,
        name="refresh-network-equipment",
    ),
    url(r"^nodes/cities/$", nodes_cities, name="nodes-cities"),
    url(r"^nodes/new/$", node_create, name="node-create"),
    url(r"^nodes/(?P<pk>\d+)/$", node_detail, name="node-detail"),
    url(r"^nodes/(?P<pk>\d+)/refresh/$", node_refresh, name="node-refresh"),
    url(r"^nodes/(?P<pk>\d+)/location/$", node_location, name="node-location"),
    url(r"^nodes/(?P<pk>\d+)/activities/$", node_activities, name="node-activities"),
    url(
        r"^nodes/(?P<pk>\d+)/activities/add/$",
        node_activity_add,
        name="node-activity-add",
    ),
    url(r"^nodes/(?P<pk>\d+)/edit/$", node_update, name="node-update"),
    url(r"^nodes/(?P<pk>\d+)/fiber/$", node_fiber_update, name="node-fiber-update"),
    url(r"^nodes/(?P<pk>\d+)/gear/$", node_gear, name="node-gear"),
    url(r"^nodes/(?P<pk>\d+)/gallery/$", node_gallery, name="node-gallery"),
    url(r"^nodes/(?P<pk>\d+)/gallery/new/$", node_gallery_add, name="node-gallery-add"),
    url(
        r"^nodes/(?P<pk>\d+)/gallery/mass-upload/$",
        node_gallery_mass_add,
        name="node-gallery-mass-add",
    ),
    url(
        r"^nodes/(?P<node_pk>\d+)/gallery/(?P<pk>\d+)/edit/$",
        node_gallery_update,
        name="node-gallery-update",
    ),
    url(r"^nodes/(?P<pk>\d+)/documents/$", node_documents, name="node-documents"),
    url(
        r"^nodes/(?P<pk>\d+)/documents/new/$",
        node_documents_add,
        name="node-documents-add",
    ),
    url(r"^nodes/(?P<pk>\d+)/services/$", node_services, name="node-services"),
    url(r"^nodes/(?P<pk>\d+)/leases/$", node_leases, name="node-leases"),
    url(r"^nodes/(?P<pk>\d+)/tie-address/$", node_tie_address, name="node-tie-address"),
    url(
        r"^nodes/untie-address/(?P<pk>\d+)/$",
        node_untie_address,
        name="node-untie-address",
    ),
    url(r"^find-availability/$", find_availability, name="find-availability"),
    url(
        r"^find-availability-api/$", find_availability_api, name="find-availability-api"
    ),
    url(
        r"^nodes/region-autocomplete/$",
        RegionAutocomplete.as_view(),
        name="region-autocomplete",
    ),
    url(
        r"^nodes/street-autocomplete/$",
        StreetAutocomplete.as_view(),
        name="street-autocomplete",
    ),
    url(
        r"^nodes/comuna-autocomplete/$",
        ComunaAutocomplete.as_view(),
        name="comuna-autocomplete",
    ),
    url(
        r"^nodes/direccion-autocomplete/$",
        DireccionAutocomplete.as_view(),
        name="direccion-autocomplete",
    ),
    url(r"^nodes/ajax/$", node_ajax, name="node-ajax"),
    url(
        r"^nodes/(?P<pk>\d+)/available-ips/$",
        node_available_ips_ajax,
        name="node-available-ips-ajax",
    ),
    url(r"^gear/$", gear_list, name="gear-list"),
    url(r"^gear/(?P<pk>\d+)/$", gear_detail, name="gear-detail"),
    url(r"^gear/ajax/$", gear_ajax, name="gear-ajax"),
    url(r"^gear/new/$", gear_create, name="gear-create"),
    url(r"^gear/(?P<pk>\d+)/edit/$", gear_update, name="gear-update"),
    url(r"^gear/(?P<pk>\d+)/gallery/$", gear_gallery, name="gear-gallery"),
    url(r"^gear/(?P<pk>\d+)/gallery/new/$", gear_gallery_add, name="gear-gallery-add"),
    url(
        r"^gear/(?P<pk>\d+)/gallery/(?P<pic_pk>\d+)/edit/$",
        gear_gallery_update,
        name="gear-gallery-update",
    ),
    url(
        r"^gear/(?P<pk>\d+)/gallery/(?P<pic_pk>\d+)/delete/$",
        gear_gallery_delete,
        name="gear-gallery-delete",
    ),
    url(r"^gear/(?P<pk>\d+)/documents/$", gear_documents, name="gear-documents"),
    url(
        r"^gear/(?P<pk>\d+)/documents/new/$",
        gear_documents_add,
        name="gear-documents-add",
    ),
    url(
        r"^gear/(?P<pk>\d+)/documents/(?P<document_pk>\d+)/edit/$",
        gear_documents_update,
        name="gear-documents-update",
    ),
    url(
        r"^gear/(?P<pk>\d+)/documents/(?P<document_pk>\d+)/delete/$",
        gear_documents_delete,
        name="gear-documents-delete",
    ),
    
]

matrix/infra/forms.py
from django.db.models import Count
from django.forms import ModelForm, Select
from django.forms.models import inlineformset_factory
from easy_select2 import apply_select2
from customers.models import Service
from .models import BuildingContact, Node, Gear, NetworkEquipment
from hr.models import Technician
from django import forms
from customers.lefu.cl_territory import COMMUNE_CHOICES
from scheduler.models import Duration
from dal import autocomplete

ContactFormSet = inlineformset_factory(Node,
                                       BuildingContact,
                                       fields=['kind',
                                               'name',
                                               'phone',
                                               'email'],
                                       max_num=3)


class DurationForm(ModelForm):
    class Meta:
        model = Duration
        fields = ['activity',
                  'duration']
        widgets = {
            'activity': apply_select2(Select),
            'duration': apply_select2(Select),
        }


class NodeForm(ModelForm):
    class Meta:
        model = Node
        fields = ['code',
                  'status',
                  'address',
                  'street',
                  'house_number',
                  'seller',
                  'commune',
                  'location',
                  'parent',
                  'default_connection_node',
                  'ip_range',
                  'mikrotik_ip',
                  'mikrotik_username',
                  'mikrotik_password',
                  'is_building',
                  'is_optical_fiber',
                  'antennas_left',
                  'towers',
                  'apartments',
                  'phone',
                  'plans',
                  'notes',
                  'plans']
        widgets = {
            'seller': apply_select2(Select),
            'parent': apply_select2(Select),
            'default_connection_node': apply_select2(Select),
            'location': apply_select2(Select),
        }


class NodeFiberForm(ModelForm):
    class Meta:
        model = Node
        fields = ['gpon',
                  'gepon',
                  'pon_port',
                  'box_location',
                  'splitter_location',
                  'expected_power',
                  'fiber_notes']


class GearForm(ModelForm):
    class Meta:
        model = Gear
        fields = ['brand',
                  'kind',
                  'ip',
                  'mac',                
                  'vlan',
                  'node',
                  'firmware_version',
                  'description',
                  'notes']
        widgets = {
            'node': apply_select2(Select),
        }

from django.forms.widgets import HiddenInput


class NetworkEquipmentForm(ModelForm):
    technician = forms.ModelChoiceField(
        queryset=Technician.objects.all(),
        widget=autocomplete.ModelSelect2(
            url='tecnicos-ac',
            attrs={
                'data-placeholder': 'Técnico',
                'class': 'form-control',
                "style": "width:100%"
                },
        ),
        required=False)

    def __init__(self, *args, **kwargs):
        if 'service_id' in kwargs:
            self.service_id = kwargs.pop('service_id')
        else:
            self.service_id = None
        super().__init__(*args, **kwargs)
        if "instance" in kwargs:
            self.fields["technician"].widget = HiddenInput()
            self.fields['technician'].label = ''
        else:
            if self.service_id:
                servicio = Service.objects.get(pk=self.service_id)
                equipos_associados = servicio.networkequipment_set.all()
                if equipos_associados.count() > 0:
                    self.fields["technician"].widget = HiddenInput()
                    self.fields['technician'].label = ''


    class Meta:
        model = NetworkEquipment
        fields = ['ip',
                  'brand',
                  'model',
                  'mac',
                  'serial_number',
                  'notes', "technician"]

    class Media:
        css = {
            'all': ('assets/plugins/select2/dist/css/select2.min.css',)
        }
        js = ('assets/plugins/select2/dist/js/select2.min.js', )




class CitiesForm(forms.Form):
    location = forms.ChoiceField(widget=apply_select2(forms.Select), required=False)
    
    def __init__(self, *args, **kwargs):
        super(CitiesForm, self).__init__(*args, **kwargs)
        self.fields['location'].choices = [('', '----')] + COMMUNE_CHOICES


from dal import autocomplete
from customers.models import Region
from customers.models import Comuna
from customers.models import Calle as Street
from customers.models import Direccion

class TieAddressForm(forms.Form):
    region = forms.ModelChoiceField(label='Región', queryset=Region.objects.annotate(num_comunas=Count('comuna')).order_by('-num_comunas'))
    comuna = forms.ModelChoiceField(queryset=Comuna.objects.all(),
                                    widget=autocomplete.ModelSelect2(url='comuna-autocomplete',
                                                                     forward=['region']))
    calle = forms.ModelChoiceField(queryset=Street.objects.all(),
                                   widget=autocomplete.ModelSelect2(url='street-autocomplete',
                                                                    forward=['comuna']))
    direccion = forms.ModelChoiceField(label='Número', queryset=Direccion.objects.all(),
                                   widget=autocomplete.ModelSelect2(url='direccion-autocomplete',
                                                                    forward=['calle']))

matrix/infra/views/mixins.py
from django.core.exceptions import PermissionDenied


class GroupRequiredMixin(object):
    """
        group_required - list of strings, required param
    """

    group_required = None

    def dispatch(self, request, *args, **kwargs):
        if not request.user.is_authenticated():
            raise PermissionDenied
        else:
            user_groups = []
            for group in request.user.groups.values_list('name', flat=True):
                user_groups.append(group)
            if len(set(user_groups).intersection(self.group_required)) <= 0:
                raise PermissionDenied
        return super(GroupRequiredMixin, self).dispatch(request, *args, **kwargs)

matrix/infra/templates/infra/gear_documents.html
{% extends "infra/base.html" %}
{% load i18n %}
{% load active_tag %}
{% load humanize %}
{% load md2 %}
{% load staticfiles %}

{% block title %}Respaldos del equipo{% endblock %}

{% block page %}
  <!-- begin breadcrumb -->
  <ol class="breadcrumb float-xl-right">
    <li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
    <li class="breadcrumb-item"><a href="{% url 'gear-list' %}">Equipos Internos</a></li>
    <li class="breadcrumb-item"><a href="{% url 'gear-detail' object.pk %}">ID: {{ object.pk }}</a></li>
    <li class="breadcrumb-item active"><a href="#">Respaldos</a></li>
  </ol>
  <!-- end breadcrumb -->

  <!-- begin page-header -->
	<h1 class="page-header">Respaldos del Equipo  <small>{{ object.description }}</small></h1>
  <!-- end page-header -->
  
  <ul class="nav nav-pills mb-2">
    <li class="nav-item" class="nav-item {% add_active request 'gear-detail' %}">
      <a href="{% url 'gear-detail' object.pk %}"class="nav-link">
        <span class="d-sm-none">General</span>
        <span class="d-sm-block d-none">General</span>
      </a>
    </li>
    <li class="nav-item {% add_active request 'gear-gallery' %}">
      <a href="{% url 'gear-gallery' object.pk %}" class="nav-link">
        <span class="d-sm-none">Galería</span>
        <span class="d-sm-block d-none">Galería</span>
      </a>
    </li>
    <li class="nav-item">
      <a href="#" class="nav-link active">
        <span class="d-sm-none">Respaldos</span>
        <span class="d-sm-block d-none">Respaldos</span>
      </a>
    </li>
  </ul>

  <!-- begin row -->
	<div class="row">
      <!-- begin col-12 -->
      <div class="col-xl-12 ui-sortable">
        <!-- begin panel -->
        <div class="panel panel-inverse" data-sortable-id="ui-general-1">
          <!-- begin panel-heading -->
          <div class="panel-heading ui-sortable-handle">
            <h4 class="panel-title">Respaldos del Equipo</h4>
            <div class="panel-heading-btn">
              <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
              <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
              <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
              <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
            </div>
          </div>
          <!-- end panel-heading -->
          <!-- begin panel-body -->
          <div class="panel-body">
            {% if perms.documents.add_document %}
              <div class="row mb-3">
                <div class="col-sm-12 col-md-12">
                </div>
              </div>
            {% endif %}
  
            {% include "documents/document_list.html" with documents=object.documents.all %}
          </div>
          <!-- end panel-body -->
        </div>
        <!-- end panel -->
      </div>
      <!-- end col-12 -->
    </div>
    <!-- end row -->
{% endblock %}

matrix/infra/templates/infra/nodes_cities.html
{% extends "customers/base.html" %}
{% load staticfiles %}
{% load active_tag %}
{% load widget_tweaks %}

{% block title %}Nodos por Ciudad{% endblock %}
{% block pagelevelcss %}
<link rel="stylesheet" type="text/css" href="{% static 'theme/plugins/eonasdan-bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.min.css' %}">
{% endblock %}


{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
    <li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
    <li class="breadcrumb-item active"><a href="#">Nodos por Ciudad</a></li>
    </ol>
  
  <!-- begin page-header -->
  <h1 class="page-header">Nodos por Ciudad <small></small></h1>
  <!-- end page-header -->


      <!-- begin row -->
      <div class="row">	  

          <!-- begin col-12 -->
          <div class="col-xl-12 ui-sortable">
              <!-- begin panel -->
              <div class="panel panel-inverse" data-sortable-id="ui-general-1">
              <!-- begin panel-heading -->
              <div class="panel-heading ui-sortable-handle">
                <h4 class="panel-title">Asociar Dirección a Nodo</h4>
                <div class="panel-heading-btn">
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
                </div>
              </div>
              <!-- end panel-heading -->
              <!-- begin panel-body -->
              <div class="panel-body">

            <form id="node-form" class="form-horizontal" method="post">
          {% csrf_token %}
          {{ form.media }}
                <div id="general" role="tabpanel" class="tab-pane active">
                    <div class="row mb-3">
                        <div class="col-sm-12 col-md-12">
                          <input class="btn btn-success btn-sm pull-right ml-1" type="submit" value="Buscar">
                        </div>
                        </div>

                        <div class="row mb-3">
                            <div class="row mb-3 m-l-10 form-inline">
                              <div class="form-group m-r-10">
                                <label for="id_city" class="control-label m-r-10">Ciudades</label>
                                {% render_field form.location class="form-control" %}
                                {% for error in form.location.errors %}
                                <small class="f-s-12 text-danger">{{ error }}</small>
                                {% endfor %}
                              </div>
                            </div>
                          </div>
                          <div class="row mb-3">
                              <div class="row mb-3 m-l-10 form-inline">
                                <div class="form-group m-r-10">
                                    <label for="not_node"  class="control-label m-r-10"></label>
                                    <small class="f-s-12 text-danger not_node">{{ error }}</small>
                                </div>
                              </div>
                            </div>
                    
                
                  
                  <div id="map" style="width: 100%; height: 500px;"></div>

          
            </form>
          </div>
          <!-- end panel-body -->
        </div>
        <!-- end panel -->
        </div>
        <!-- end col-12 -->
        
        
        </div>
        <!-- end row -->
        
        <!-- begin scroll to top btn -->
        <a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
        <!-- end scroll to top btn -->
        
        {% endblock %}


    {% block pageleveljs %}
    <script type="text/javascript">
    //active menu
    document.getElementById("infra_menu").classList.add("active");
    //active submenu item
    document.getElementById("nodecities_item").classList.add("active");
</script>

    <script src="https://maps.google.com/maps/api/js?sensor=false&key=AIzaSyB4AeY8Ts757OtL6PHEqHCLzsHk0L6NXUo&sensor=false" type="text/javascript"></script>
    <script>
    var address_maps = {
        data: []
    };
    nodes = [];
    {% for node in nodes %}
        nodes.push("{{ node.address|safe }}");
        //console.log("{{ node.address }}");
    {% endfor %}
    </script>
    <script>
     for (x=0;x<nodes.length;x++){
      $.ajax
      ({
        async: false,
        url:"https://maps.googleapis.com/maps/api/geocode/json?key=AIzaSyB4AeY8Ts757OtL6PHEqHCLzsHk0L6NXUo&address="+nodes[x]+"&sensor=false",
        type: "POST",
          success:function(res)
          {
            address_maps.data.push
            ({ 
                "address" : nodes[x], 
                "latitude" : res.results[0].geometry.location.lat,
                "longitud"  :res.results[0].geometry.location.lng,
                "id" : x,
            });
          }
      });
    }
    </script>

<script type="text/javascript">
if (nodes.length > 0 ){
        var map = new google.maps.Map(document.getElementById('map'), {
      zoom: 15,
      center: new google.maps.LatLng(address_maps.data[0]["latitude"], address_maps.data[0]["longitud"]),
      mapTypeId: google.maps.MapTypeId.ROADMAP
    });



    var infowindow = new google.maps.InfoWindow();

    var marker, i;

    for (i = 0; i < address_maps.data.length; i++) {  
      address_maps.data
      marker = new google.maps.Marker({
        position: new google.maps.LatLng(address_maps.data[i]["latitude"], address_maps.data[i]["longitud"]),


        map: map
      });

      google.maps.event.addListener(marker, 'click', (function(marker, i) {
        return function() {
          infowindow.setContent(address_maps.data[i]["address"]);
          infowindow.open(map, marker);
        }
      })(marker, i));
    }
    
}

$(function() {
    val = $("#id_location").val();
    city_name = $("#id_location option:selected").text();
    if (nodes.length == 0 ) {
        if (val != ""){
            $(".not_node").text("No se encontraron nodos en la ciudad de " +city_name);
        }
    }

});

</script>

<!-- Work Here end-->
{% endblock %}